///home/berryj/link/bin/genMethods "-t" "Attribute<double>*" "-I" "LINK/graph/Attribute.h" "-d" "graph" "-y" "display_attribute_doubleptr" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/Attribute.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_attribute_doubleptr(SCM, SCM, int);

typedef Attribute<double>* _Attribute_double__;

#define _Attribute_double__DATA(x) ((Attribute<double>**) (EXTDATA(x)))
#define _Attribute_double__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Attribute<double>* >::type))
#define _Attribute_double__ISNT_DATA(x) (!_Attribute_double__IS_DATA(x))

#define _Attribute_double__CXX_DATA(x) (*(Attribute<double>**) (EXTDATA(VAL(x))))
#define _Attribute_double__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Attribute<double>* >::type))
#define _Attribute_double__CXX_ISNT_DATA(x) (!_Attribute_double__CXX_IS_DATA(x))


static SCM is_Attribute_double__(SCM i)
{
	if (_Attribute_double__CXX_IS_DATA(i))
		return Truth;
	return Ntruth;
}

PRIMITIVE STk_init__Attribute_double__()
{
	Wrapper<_Attribute_double__>::type = STk_new_CXXwrapper_id(
			Wrapper<_Attribute_double__>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			display_attribute_doubleptr,
			(void (*)(SCM x))0,
			(void (*)(SCM x))0);
	Tcl_InitHashTable(&Register<_Attribute_double__>::objTable, TCL_ONE_WORD_KEYS);
	STk_add_new_cpp_primitive("Attribute-double?", tc_subr_1,
	(PRIMITIVE (*)(...))  is_Attribute_double__);
	return UNDEFINED;
}

void genExtra_Attribute_double__Methods(void);

PRIMITIVE STk_init_methods__Attribute_double__()
{
	genExtra_Attribute_double__Methods();
	return UNDEFINED;
}
